*IK*	  03/10/2004 IK
*IK*	    nAnchor   ResizeCnt,
*IK*	  

PROCEDURE ResetBaseLayout
LPARAMETERS toControl
*   ""  
* (      
*  )
LOCAL lnCntWidth, lnCntHeight
IF PEMSTATUS(m.toControl, "nBaseLeft", 5)
	m.toControl.nBaseLeft = m.toControl.Left
ELSE
	m.toControl.AddProperty("nBaseLeft", m.toControl.Left)
ENDIF
IF PEMSTATUS(m.toControl, "nBaseTop", 5)
	m.toControl.nBaseTop = m.toControl.Top
ELSE
	m.toControl.AddProperty("nBaseTop", m.toControl.Top)
ENDIF
IF PEMSTATUS(m.toControl, "nBaseWidth", 5)
	m.toControl.nBaseWidth = MAX(m.toControl.Width, 1)
ELSE
	m.toControl.AddProperty("nBaseWidth", MAX(m.toControl.Width, 1))
ENDIF
IF PEMSTATUS(m.toControl, "nBaseHeight", 5)
	m.toControl.nBaseHeight = MAX(m.toControl.Height, 1)
ELSE
	m.toControl.AddProperty("nBaseHeight", MAX(m.toControl.Height, 1))
ENDIF
IF TYPE("m.toControl.Parent.Name") = "C"
	IF PEMSTATUS(m.toControl.Parent, "Width", 5)
		lnCntWidth = m.toControl.Parent.Width
	ELSE
		IF PEMSTATUS(m.toControl.Parent.Parent, "PageWidth", 5)
			lnCntWidth = m.toControl.Parent.Parent.PageWidth
		ELSE
			* If error that oContainer.Width and oContainer.parent.Width not exist, something wrong
			lnCntWidth = m.toControl.Parent.Parent.Width
		ENDIF
	ENDIF
ELSE
	lnCntWidth = m.toControl.Width
ENDIF
IF PEMSTATUS(m.toControl, "nCntBaseWidth", 5)
	m.toControl.nCntBaseWidth = MAX(m.lnCntWidth, 1)
ELSE
	m.toControl.AddProperty("nCntBaseWidth", MAX(m.lnCntWidth, 1))
ENDIF
IF TYPE("m.toControl.Parent.Name") = "C"
	IF PEMSTATUS(m.toControl.Parent, "Height", 5)
		lnCntHeight = m.toControl.Parent.Height
	ELSE
		IF PEMSTATUS(m.toControl.Parent.Parent, "PageHeight", 5)
			lnCntHeight = m.toControl.Parent.Parent.PageHeight
		ELSE
			* If error that oContainer.Height and oContainer.parent.Height not exist, something wrong
			lnCntHeight = m.toControl.Parent.Parent.Height
		ENDIF
	ENDIF
ELSE
	lnCntHeight = m.toControl.Height
ENDIF
IF PEMSTATUS(m.toControl, "nCntBaseHeight", 5)
	m.toControl.nCntBaseHeight = MAX(m.lnCntHeight, 1)
ELSE
	m.toControl.AddProperty("nCntBaseHeight", MAX(m.lnCntHeight, 1))
ENDIF
ENDPROC

PROCEDURE ResizeCnt
LPARAMETERS toCnt, tnNewWidth, tnNewHeight
*      
*       nAnchor
*  / 
*   ,    
*    , ..  Page 
*   PageFrame.PageWidth  PageFrame.PageHeight
* 
LOCAL loObj, lnAnchor, lnLeft, lnTop, lnWidth, lnHeight
FOR EACH loObj IN m.toCnt.Objects
	*     
	lnAnchor = IIF(TYPE("m.loObj.nAnchor") = "N", m.loObj.nAnchor, 0)
	IF m.lnAnchor # 0 AND TYPE("m.loObj.nBaseLeft") = "N" AND ;
			TYPE("m.loObj.nBaseTop") = "N" AND ;
			TYPE("m.loObj.nBaseWidth") = "N" AND ;
			TYPE("m.loObj.nBaseHeight") = "N" AND ;
			TYPE("m.loObj.nCntBaseWidth") = "N" AND ;
			TYPE("m.loObj.nCntBaseHeight") = "N" AND ;
			TYPE("m.loObj.Left") = "N" AND ;
			TYPE("m.loObj.Top") = "N" AND ;
			TYPE("m.loObj.Width") = "N" AND ;
			TYPE("m.loObj.Height") = "N" AND ;
			PEMSTATUS(m.loObj, "Move", 5) AND ;
			PEMSTATUS(m.loObj, "Move", 3) = "Method"
		*             

		lnLeft = m.loObj.Left
		lnTop = m.loObj.Top
		lnWidth = m.loObj.Width
		lnHeight = m.loObj.Height

		* 
		ln1 = BITAND(m.lnAnchor, 0x29AA)
		DO CASE
		CASE m.ln1 = 0
			*    
		CASE m.ln1 = 2
			*   
			*       
			lnLeft = m.loObj.nBaseLeft
			lnWidth = m.loObj.nBaseWidth
		CASE m.ln1 = 8
			*   
			* ,     
			lnLeft = m.loObj.nBaseLeft + m.tnNewWidth - m.loObj.nCntBaseWidth
			lnWidth = m.loObj.nBaseWidth
		CASE m.ln1 = 8 + 2
			*  ,        
			*     
			lnLeft = m.loObj.nBaseLeft
			lnWidth = m.loObj.nBaseWidth + m.tnNewWidth - m.loObj.nCntBaseWidth
		CASE m.ln1 = 32
			*    
			* ,     
			lnLeft = m.loObj.nBaseLeft * m.tnNewWidth / MAX(m.loObj.nCntBaseWidth, 1)
			lnWidth = m.loObj.nBaseWidth
		CASE m.ln1 = 32 + 8
			*    ,   
			*      
			lnLeft = m.loObj.nBaseLeft * m.tnNewWidth / MAX(m.loObj.nCntBaseWidth, 1)
			lnWidth = m.tnNewWidth - m.loObj.nCntBaseWidth - m.lnLeft + m.loObj.nBaseLeft + m.loObj.nBaseWidth
		CASE m.ln1 = 128
			*    ,  
			lnLeft = (m.loObj.nBaseLeft + m.loObj.nBaseWidth) * m.tnNewWidth / MAX(m.loObj.nCntBaseWidth, 1) - m.loObj.nBaseWidth
			lnWidth = m.loObj.nBaseWidth
		CASE m.ln1 = 128 + 2
			*    ,   
			*      
			lnLeft = m.loObj.nBaseLeft
			lnWidth = (m.loObj.nBaseLeft + m.loObj.nBaseWidth) * m.tnNewWidth / MAX(m.loObj.nCntBaseWidth, 1) - m.lnLeft
		CASE m.ln1 = 128 + 32
			*      
			lnLeft = m.loObj.nBaseLeft * m.tnNewWidth / MAX(m.loObj.nCntBaseWidth, 1)
			lnWidth = (m.loObj.nBaseLeft + m.loObj.nBaseWidth) * m.tnNewWidth / MAX(m.loObj.nCntBaseWidth, 1) - m.lnLeft
		CASE m.ln1 = 256
			*    ,    
			*   ,   
			lnLeft = (m.loObj.nBaseLeft + m.loObj.nBaseWidth / 2) * m.tnNewWidth / MAX(m.loObj.nCntBaseWidth, 1) - (m.loObj.nBaseWidth / 2)
			lnWidth = m.loObj.nBaseWidth
		CASE m.ln1 = 2048
			*    (    )
			*  
			lnLeft = 0
			lnWidth = m.loObj.nBaseWidth
		CASE m.ln1 = 2048 + 8
			*    (    )
			*   ,     
			lnLeft = 0
			lnWidth = m.loObj.nBaseLeft + m.loObj.nBaseWidth + m.tnNewWidth - m.loObj.nCntBaseWidth
		CASE m.ln1 = 2048 + 128
			*    (    )
			*   ,     
			lnLeft = 0
			lnWidth = (m.loObj.nBaseLeft + m.loObj.nBaseWidth) * m.tnNewWidth / MAX(m.loObj.nCntBaseWidth, 1)
		CASE m.ln1 = 8192
			*    (    )
			*  
			lnLeft = m.tnNewWidth - m.loObj.nBaseWidth
			lnWidth = m.loObj.nBaseWidth
		CASE m.ln1 = 8192 + 2
			*    (    )
			*   ,     
			lnLeft = m.loObj.nBaseLeft
			lnWidth = m.tnNewWidth - m.loObj.nBaseLeft
		CASE m.ln1 = 8192 + 32
			*    (    )
			*   ,     
			lnLeft = m.loObj.nBaseLeft * m.tnNewWidth / MAX(m.loObj.nCntBaseWidth, 1)
			lnWidth = m.tnNewWidth - m.lnLeft
		CASE m.ln1 = 8192 + 2048
			*      (      )
			*    
			lnLeft = 0
			lnWidth = m.tnNewWidth
		OTHERWISE
			*  
			ERROR "nAnchor property value for " + SYS(1272, m.loObj) + " is invalid"
		ENDCASE

		* 
		ln1 = BITAND(m.lnAnchor, 0x1655)
		DO CASE
		CASE m.ln1 = 0
			*    
		CASE m.ln1 = 1
			*   
			*       
			lnTop = m.loObj.nBaseTop
			lnHeight = m.loObj.nBaseHeight
		CASE m.ln1 = 4
			*   
			* ,     
			lnTop = m.loObj.nBaseTop + m.tnNewHeight - m.loObj.nCntBaseHeight
			lnHeight = m.loObj.nBaseHeight
		CASE m.ln1 = 4 + 1
			*   ,       
			*     
			lnTop = m.loObj.nBaseTop
			lnHeight = m.loObj.nBaseHeight + m.tnNewHeight - m.loObj.nCntBaseHeight
		CASE m.ln1 = 16
			*    
			* ,     
			lnTop = m.loObj.nBaseTop * m.tnNewHeight / MAX(m.loObj.nCntBaseHeight, 1)
			lnHeight = m.loObj.nBaseHeight
		CASE m.ln1 = 16 + 4
			*    ,   
			*      
			lnTop = m.loObj.nBaseTop * m.tnNewHeight / MAX(m.loObj.nCntBaseHeight, 1)
			lnHeight = m.tnNewHeight - m.loObj.nCntBaseHeight - m.lnTop + m.loObj.nBaseTop + m.loObj.nBaseHeight
		CASE m.ln1 = 64
			*    ,  
			lnTop = (m.loObj.nBaseTop + m.loObj.nBaseHeight) * m.tnNewHeight / MAX(m.loObj.nCntBaseHeight, 1) - m.loObj.nBaseHeight
			lnHeight = m.loObj.nBaseHeight
		CASE m.ln1 = 64 + 1
			*    ,   
			*      
			lnTop = m.loObj.nBaseTop
			lnHeight = (m.loObj.nBaseTop + m.loObj.nBaseHeight) * m.tnNewHeight / MAX(m.loObj.nCntBaseHeight, 1) - m.lnTop
		CASE m.ln1 = 64 + 16
			*      
			lnTop = m.loObj.nBaseTop * m.tnNewHeight / MAX(m.loObj.nCntBaseHeight, 1)
			lnHeight = (m.loObj.nBaseTop + m.loObj.nBaseHeight) * m.tnNewHeight / MAX(m.loObj.nCntBaseHeight, 1) - m.lnTop
		CASE m.ln1 = 512
			*    ,    
			*   ,   
			lnTop = (m.loObj.nBaseTop + m.loObj.nBaseHeight / 2) * m.tnNewHeight / MAX(m.loObj.nCntBaseHeight, 1) - (m.loObj.nBaseHeight / 2)
			lnHeight = m.loObj.nBaseHeight
		CASE m.ln1 = 1024
			*    (    )
			*  
			lnTop = 0
			lnHeight = m.loObj.nBaseHeight
		CASE m.ln1 = 1024 + 4
			*    (    )
			*   ,     
			lnTop = 0
			lnHeight = m.loObj.nBaseTop + m.loObj.nBaseHeight + m.tnNewHeight - m.loObj.nCntBaseHeight
		CASE m.ln1 = 1024 + 64
			*    (    )
			*   ,     
			lnTop = 0
			lnHeight = (m.loObj.nBaseTop + m.loObj.nBaseHeight) * m.tnNewHeight / MAX(m.loObj.nCntBaseHeight, 1)
		CASE m.ln1 = 4096
			*    (    )
			*  
			lnTop = m.tnNewHeight - m.loObj.nBaseHeight
			lnHeight = m.loObj.nBaseHeight
		CASE m.ln1 = 4096 + 1
			*    (    )
			*   ,     
			lnTop = m.loObj.nBaseTop
			lnHeight = m.tnNewHeight - m.loObj.nBaseTop
		CASE m.ln1 = 4096 + 16
			*    (    )
			*   ,     
			lnTop = m.loObj.nBaseTop * m.tnNewHeight / MAX(m.loObj.nCntBaseHeight, 1)
			lnHeight = m.tnNewHeight - m.lnTop
		CASE m.ln1 = 4096 + 1024
			*      (      )
			*    
			lnTop = 0
			lnHeight = m.tnNewHeight
		OTHERWISE
			*  
			ERROR "nAnchor property value for " + SYS(1272, m.loObj) + " is invalid"
		ENDCASE

		lnWidth = MAX(m.lnWidth, 0)
		lnHeight = MAX(m.lnHeight, 0)
		*  Move   Resize event   
		m.loObj.Move(CEILING(m.lnLeft), CEILING(m.lnTop), CEILING(m.lnWidth), CEILING(m.lnHeight))
	ENDIF
ENDFOR
ENDPROC